// ===========================================================================
//	ArchitectureFlags.h		(C) 2007 Mark F. Coniglio	  All rights reserved.
// ===========================================================================

#ifndef _H_ArchitectureFlags
#define _H_ArchitectureFlags

// The Target Platform switches must be defined
// this point; these #ifndef's will generate an
// error if they are not.

#ifndef TARGET_CPU_PPC
	#error "TARGET_CPU_PPC must be defined here"
#endif

#ifndef TARGET_CPU_X86
	#error "TARGET_CPU_X86 must be defined here"
#endif

#ifndef TARGET_CPU_X86_64
	#error "TARGET_CPU_X86_64 must be defined here"
#endif

#ifndef TARGET_CPU_ARM64
	#error "TARGET_CPU_ARM64 must be defined here"
#endif

#ifndef COMPILE_ASM
#define COMPILE_ASM		1
#endif

#ifdef __MWERKS__
	// to accomodate the old Metrowerks Compilers
	#define	ASM	asm
#else
	// for modern GCC on Mac OS and for Windows
	#define ASM _asm
#endif

//
// Flags for Compiling X86 Asembler Code
//
// For the Isadora Application and TroikaTronix's internally
// built plugins these switches will be true. (To compile asm
// on Mac OS X requires a special installation of XCode that
// provides legacy versions of the GCC compilers.)
//
// For the Isadora SDK, these switches will always be false
// do the existence of the __ISADORA_NO_ASM__ flag in the
//

#ifdef __ISADORA_NO_ASM__
	#define	ALLOW_ASM			0
#else
	#define	ALLOW_ASM			1
#endif

#if defined(__ISADORA_APP__)
#define ASM_ISADORA_APP_DEFINED 1
#else
#define ASM_ISADORA_APP_DEFINED 0
#endif

#define INLINE_X86_ASM			(ALLOW_ASM && (TARGET_CPU_X86 && (ASM_ISADORA_APP_DEFINED || TARGET_OS_WIN)))
#define SSE_EXTENSIONS_LIB		(ALLOW_ASM && (TARGET_CPU_X86))
#define	SSE_EXTENSIONS			(ALLOW_ASM && (TARGET_CPU_X86 && (ASM_ISADORA_APP_DEFINED || TARGET_OS_WIN)))

// Isadora no longer supports PowerPC code
// so these are now all defined as FALSE

#define INLINE_PPC_ASM			FALSE
#define ALTIVEC_EXTENSIONS_LIB	FALSE
#define ALTIVEC_EXTENSIONS		FALSE


#endif

