// =================================================================================
//	IZGLFunctions					(c)2003 Mark F. Coniglio. All rights reserved.
// =================================================================================
#ifndef _H_CGLFunctions
#define _H_CGLFunctions

// WARNING WARNING: ONLY ADD NEW FUNCTIONS TO THE END
// OF THE CLASS OTHERWISE EXISTING PLUGINS MAY CRASH!

#define COMPILE_CGL_FUNCTIONS				1
#define CGLFUNCTIONS_GET_FUNCTION_POINTERS	TARGET_OS_WIN

#define USE_CGL_FUNCTIONS					(TARGET_OS_MAC || (COMPILE_CGL_FUNCTIONS && CGLFUNCTIONS_GET_FUNCTION_POINTERS))

#include "CPlusPlusMacros.h"
#include "OpenGLIncludes.h"

#if COMPILE_CGL_FUNCTIONS

// ---------------------------------------------------------------------------
// IZGLFunctions CLASS
// ---------------------------------------------------------------------------

CLASSHDR CIZGLFunctions
{
PUBLIC
// CONSTRUCTOR
							#ifdef __cplusplus

// WARNING WARNING: ONLY ADD NEW FUNCTIONS TO THE END!

							CIZGLFunctions() :
								
								mGLFuncInitialized(false),
								mHasMultisamplingExtension(false)
							
								#if CGLFUNCTIONS_GET_FUNCTION_POINTERS
								
								,
								
								wglSwapIntervalEXT(NULL),
								wglGetSwapIntervalEXT(NULL),
								wglChoosePixelFormatARB(NULL),
								wglGetExtensionsStringARB(NULL),
								wglGetExtensionsStringEXT(NULL),
								
								wglBlendColor(NULL),
								wglBlendFuncSeparate(NULL),
								wglBlendEquationSeparate(NULL),

								wgl_ARB_MultisampleFormat(0),

// WARNING WARNING: ONLY ADD NEW FUNCTIONS TO THE END!

								wglAcquiredAllPBOProcAddresses(false),
								wglGenBuffersARB(NULL),
								wglDeleteBuffersARB(NULL),
								wglBindBufferARB(NULL),
								wglMapBufferARB(NULL),
								wglUnmapBufferARB(NULL),
								wglBufferDataARB(NULL),
								wglGetBufferParameterivARB(NULL),
								wglBufferSubDataARB(NULL),

								wglGenFramebuffersEXT(NULL),
								wglDeleteFramebuffersEXT(NULL),
								wglBindFramebufferEXT(NULL),
								wglFramebufferRenderbufferEXT(NULL),
								wglFramebufferTexture2DEXT(NULL),
								wglCheckFramebufferStatusEXT(NULL),

								wglGenRenderbuffersEXT(NULL),
								wglDeleteRenderbuffersEXT(NULL),
								wglBindRenderbufferEXT(NULL),
								wglRenderbufferStorageEXT(NULL),
								wglGenerateMipmapEXT(NULL),

// WARNING WARNING: ONLY ADD NEW FUNCTIONS TO THE END!

								// GLSL SHADERS
								wglAcquiredAllGLSLAddresses(false),
								wglCreateShaderObjectARB(NULL),
								wglCreateProgramObjectARB(NULL),
								wglDeleteObjectARB(NULL),
								wglShaderSourceARB(NULL),
								wglCompileShaderARB(NULL),
								wglLinkProgramARB(NULL),
								wglGetObjectParameterivARB(NULL),
								wglGetInfoLogARB(NULL),
								wglAttachObjectARB(NULL),
								wglUseProgramObjectARB(NULL),
	
								wglGetUniformLocationARB(NULL),
								wglUniform1f(NULL),
								wglUniform2f(NULL),
								wglUniform3f(NULL),
								wglUniform4f(NULL),
	
								wglActiveTexture(NULL),
								wglClientActiveTexture(NULL),

								wglUniform1i(NULL),
								wglUniform2i(NULL),
								wglUniform3i(NULL),
								wglUniform4i(NULL),
	
								wglGetAttribLocationARB(NULL),
								wglVertexAttribPointer(NULL),
								wglEnableVertexAttribArray(NULL),
								wglDisableVertexAttribArray(NULL),

// WARNING WARNING: ONLY ADD NEW FUNCTIONS TO THE END!

								wglIsFramebufferEXT(NULL),

								// added 2.9b15
								wglCompressedTexSubImage2D(NULL),
								wglActiveTextureARB(NULL)

								#endif
							{
							}

							#endif // #ifdef __cplusplus
						
// LOAD FUNCTION POINTERS
	void	LoadOpenGLFunctionPointers();

// MEMBER FUNCTIONS
	bool								mGLFuncInitialized;

	// NOTE: this is initialized by CGLContextBase
	// not by IZGLFunctions
	bool								mHasMultisamplingExtension;

#if CGLFUNCTIONS_GET_FUNCTION_POINTERS

	// SWAP INTERVAL PROC
	PFNWGLSWAPINTERVALEXTPROC			wglSwapIntervalEXT;
	PFNWGLGETSWAPINTERVALEXTPROC		wglGetSwapIntervalEXT;

	PFNWGLCHOOSEPIXELFORMATARBPROC		wglChoosePixelFormatARB;
	
// EXTENSION STRING PROCS
	PFNWGLGETEXTENSIONSSTRINGARBPROC	wglGetExtensionsStringARB;
	PFNWGLGETEXTENSIONSSTRINGEXTPROC	wglGetExtensionsStringEXT;

// GL 2.0
	PFNGLBLENDCOLORPROC					wglBlendColor;
	PFNGLBLENDFUNCSEPARATEPROC			wglBlendFuncSeparate;
	PFNGLBLENDEQUATIONSEPARATEPROC		wglBlendEquationSeparate;
	
// MUTISAMPLING
	int									wgl_ARB_MultisampleFormat;
	
// PIXEL BUFFER OBJECTS
	bool								wglAcquiredAllPBOProcAddresses;

	PFNGLGENBUFFERSARBPROC				wglGenBuffersARB;
	PFNGLDELETEBUFFERSARBPROC			wglDeleteBuffersARB;
	PFNGLBINDBUFFERARBPROC				wglBindBufferARB;
	PFNGLMAPBUFFERARBPROC				wglMapBufferARB;
	PFNGLUNMAPBUFFERARBPROC				wglUnmapBufferARB;
	PFNGLBUFFERDATAARBPROC				wglBufferDataARB;
	PFNGLGETBUFFERPARAMETERIVARBPROC	wglGetBufferParameterivARB;
	PFNGLBUFFERSUBDATAARBPROC			wglBufferSubDataARB;

	PFNGLGENFRAMEBUFFERSEXTPROC			wglGenFramebuffersEXT;
	PFNGLDELETEFRAMEBUFFERSEXTPROC		wglDeleteFramebuffersEXT;
	PFNGLBINDFRAMEBUFFEREXTPROC			wglBindFramebufferEXT;
	PFNGLFRAMEBUFFERRENDERBUFFEREXTPROC	wglFramebufferRenderbufferEXT;
	PFNGLFRAMEBUFFERTEXTURE2DEXTPROC	wglFramebufferTexture2DEXT;
	PFNGLCHECKFRAMEBUFFERSTATUSEXTPROC	wglCheckFramebufferStatusEXT;
	//  wglIsFramebufferEXT belongs to this group but wasn't added until 2.5.2


	PFNGLGENRENDERBUFFERSEXTPROC		wglGenRenderbuffersEXT;
	PFNGLDELETERENDERBUFFERSEXTPROC		wglDeleteRenderbuffersEXT;
	PFNGLBINDRENDERBUFFEREXTPROC		wglBindRenderbufferEXT;
	PFNGLRENDERBUFFERSTORAGEEXTPROC		wglRenderbufferStorageEXT;
	PFNGLGENERATEMIPMAPEXTPROC			wglGenerateMipmapEXT;

// GLSL SHADERS
	bool								wglAcquiredAllGLSLAddresses;
	
	PFNGLCREATESHADEROBJECTARBPROC		wglCreateShaderObjectARB;
	PFNGLCREATEPROGRAMOBJECTARBPROC		wglCreateProgramObjectARB;
	PFNGLDELETEOBJECTARBPROC			wglDeleteObjectARB;
	PFNGLSHADERSOURCEARBPROC			wglShaderSourceARB;
	PFNGLCOMPILESHADERARBPROC			wglCompileShaderARB;
	PFNGLLINKPROGRAMARBPROC				wglLinkProgramARB;
	PFNGLGETOBJECTPARAMETERIVARBPROC	wglGetObjectParameterivARB;
	PFNGLGETINFOLOGARBPROC				wglGetInfoLogARB;
	PFNGLATTACHOBJECTARBPROC			wglAttachObjectARB;
	PFNGLUSEPROGRAMOBJECTARBPROC		wglUseProgramObjectARB;

	PFNGLGETUNIFORMLOCATIONARBPROC		wglGetUniformLocationARB;
	PFNGLUNIFORM1FPROC					wglUniform1f;
	PFNGLUNIFORM2FPROC					wglUniform2f;
	PFNGLUNIFORM3FPROC					wglUniform3f;
	PFNGLUNIFORM4FPROC					wglUniform4f;

	PFNGLACTIVETEXTUREPROC				wglActiveTexture;
	PFNGLCLIENTACTIVETEXTUREPROC		wglClientActiveTexture;

	PFNGLUNIFORM1IPROC					wglUniform1i;
	PFNGLUNIFORM2IPROC					wglUniform2i;
	PFNGLUNIFORM3IPROC					wglUniform3i;
	PFNGLUNIFORM4IPROC					wglUniform4i;

	// v2.2.3 and later
	PFNGLGETATTRIBLOCATIONARBPROC		wglGetAttribLocationARB;
	PFNGLVERTEXATTRIBPOINTERPROC		wglVertexAttribPointer;
	PFNGLENABLEVERTEXATTRIBARRAYPROC	wglEnableVertexAttribArray;
	PFNGLDISABLEVERTEXATTRIBARRAYPROC	wglDisableVertexAttribArray;

	// v2.5.2 and later
	PFNGLISFRAMEBUFFEREXTPROC			wglIsFramebufferEXT;

	// v2.9b15 and later
	PFNGLACTIVETEXTUREARBPROC			wglActiveTextureARB;
	PFNGLCOMPRESSEDTEXSUBIMAGE2DARBPROC	wglCompressedTexSubImage2D;

#endif
};

#else

typedef void IZGLFunctions;

#endif	// #if USE_CGL_FUNCTIONS

#endif // #ifndef _H_CGLFunctions

