// ===========================================================================
//	CaptureConstants			  (C)2002 Mark F. Coniglio. All rights reserved.
// ===========================================================================
// Defines constants used with the SetCaptureMode_ function defined in
// IsadoraCallbacks.h

#ifndef _H_CaptureConstants
#define _H_CaptureConstants

// typedef UInt8	CaptureEnable;

enum CaptureEnable {
	kCaptureEnableDefault,
	kCaptureEnabled,
	kCaptureDisabled
};
	
typedef	UInt8	CaptureSize;

enum
{
	kCaptureSizeDefault = 0,	// used for overrides only
	
	kCaptureSizeNative,			// native capture size for device
	
	kCaptureSize1920x1080,		// Full HD - 1080p
	kCaptureSize1280x720,		// Full HD - 720p
	kCaptureSize1024x576,		// 
	kCaptureSize960x540,		// Half HD
	kCaptureSize640x360,		// Quarter HD
	kCaptureSize320x180,		// Eighth HD
	
	kCaptureSize1024x768,		// XGA
	kCaptureSize800x600,		// SVGA
	kCaptureSize640x480,		// Full 4x3 NTSC
	kCaptureSize320x240,		// Half 4x3 NTSC
	kCaptureSize160x120,		// Quarter 4x3 NTSC
	
	kCaptureSize768x576,		// Full 4x3 PAL
	kCaptureSize384x288, 		// Half 4x3 PAL
	kCaptureSize192x144,		// Quarter 4x3 PAL
	
	kCaptureSize3840x2160,		// Ultra HD
	kCaptureSize2560x1440,		// Quad HD
	
	kCaptureSizeCustom			// Custom Size
};

static const CaptureSize	kCaptureSizeInvalid = (CaptureSize) -1;

/*
typedef	UInt8	CaptureQuality;

enum
{
	kCaptureQualityInvalid = 0,
	kCaptureQualityMaximum,
	kCaptureQualityHigh,
	kCaptureQualityNormal,
	kCaptureQualityLow,
	kCaptureQualityMinimum
};

*/

#endif
