// ===========================================================================
//	ColorConversion				(c) 2015 Mark F. Coniglio. All rights reserved
// ===========================================================================

#ifndef _H_ColorConversion
#define _H_ColorConversion

#include "IZQDTypes.h"

#if TARGET_OS_WIN
#include <ColorPicker.h>
#endif

#define		PERFORM_COLOR_UNIT_TEST		(FALSE && DEBUG)

RGBColor HSV2RGB_FixedPoint(const QDHSVColor& c);
QDHSVColor RGB2HSV_FixedPoint(const RGBColor c);

// v2.6 ->
void
RGBtoHSV (
	double r, double g, double b,
	double& H, double& S, double& V,
	double inRGBDivisor = 1.0);

void
HSVtoRGB (
	double H, double S, double V,
	double&	r, double&	g, double& b,
	double inRGBMultiplier = 1.0);

void
RGBtoHSL (
	double r, double g, double b,
	double& H, double& S, double& L);

void
HSLtoRGB (
	double H, double S, double L,
	double&	r, double&	g, double& b);

// v2.6 <-

#if PERFORM_COLOR_UNIT_TEST
void ColorUnitTest();
#endif

#endif
