// =================================================================================
//	IZGraphics						(c) 2016 Mark F. Coniglio -- All Rights Reserved
// =================================================================================

#ifndef _H_IZGraphics
#define _H_IZGraphics

// kIzGraphcisMode_XXX
enum {
	kIzGraphicsMode_SrcCopy                       = 0,
	kIzGraphicsMode_SrcOr                         = 1,
	kIzGraphicsMode_SrcXor                        = 2,
	kIzGraphicsMode_SrcBic                        = 3,
	kIzGraphicsMode_NotSrcCopy                    = 4,
	kIzGraphicsMode_NotSrcOr                      = 5,
	kIzGraphicsMode_NotSrcXor                     = 6,
	kIzGraphicsMode_NotSrcBic                     = 7,
	kIzGraphicsMode_PatCopy                       = 8,
	kIzGraphicsMode_PatOr                         = 9,
	kIzGraphicsMode_PatXor                        = 10,
	kIzGraphicsMode_PatBic                        = 11,
	kIzGraphicsMode_NotPatCopy                    = 12,
	kIzGraphicsMode_NotPatOr                      = 13,
	kIzGraphicsMode_NotPatXor                     = 14,
	kIzGraphicsMode_NotPatBic                     = 15,

	kIzGraphicsMode_GrayishTextOr                 = 49,
	kIzGraphicsMode_Hilitetransfermode            = 50,

	kIzGraphicsMode_Hilite                        = 50,
	kIzGraphicsMode_Blend                         = 32,
	kIzGraphicsMode_AddPin                        = 33,
	kIzGraphicsMode_AddOver                       = 34,
	kIzGraphicsMode_SubPin                        = 35,
	kIzGraphicsMode_AddMax                        = 37,
	kIzGraphicsMode_AdMax                         = 37,
	kIzGraphicsMode_SubOver                       = 38,
	kIzGraphicsMode_AdMin                         = 39,
	kIzGraphicsMode_DitherCopy                    = 64,
	kIzGraphicsMode_Transparent                   = 36
};

/* Source transfer modes */
#define kIzGraphicsMode_SrcCopy 	0
#define kIzGraphicsMode_SrcOr		1
#define kIzGraphicsMode_SrcXor		2
#define kIzGraphicsMode_SrcBic		3
#define kIzGraphicsMode_NotSrcCopy	4
#define kIzGraphicsMode_NotSrcOr	5
#define kIzGraphicsMode_NotSrcXor	6
#define kIzGraphicsMode_NotSrcBic	7

/* patterm transfer modes */
#define kIzGraphicsMode_PatCopy		8
#define kIzGraphicsMode_PatOr		9
#define kIzGraphicsMode_PatXor		10
#define kIzGraphicsMode_PatBic		11
#define kIzGraphicsMode_NotPatCopy	12
#define kIzGraphicsMode_NotPatOr	13
#define kIzGraphicsMode_NotPatXor	14
#define kIzGraphicsMode_NotPatBic	15

#define kIzGraphicsMode_Blend		32
#define kIzGrayishTextOr			17

#define kIzCheckMarkChar			0x12

enum {
    kIzSystemFont                  = 0,
    kIzApplFont                    = 1
};

// ---------------------------------------------------------------------------------
//	DEFINES
// ---------------------------------------------------------------------------------

#define CGCTX_DRAW				TARGET_OS_MAC
#define	GDI_DRAW				TARGET_OS_WIN
#define	QD_DRAW					FALSE

// ---------------------------------------------------------------------------------
// PIXEL DEPTH
typedef SInt16	IZPixelDepth;	// pixel depth specifier (8 bit, 32 bit, etc.)

// ---------------------------------------------------------------------------------
// GRAPHICS PEN MODE
typedef	SInt16	IzPenMode;		// equates to old QD transfer modes: kIzGraphicsMode_SrcOr, kIzGraphicsMode_SrcCopy, etc.

// ---------------------------------------------------------------------------------
// QUICKDRAW POINT

struct QDPoint {
  short               v;
  short               h;
};
typedef struct QDPoint	QDPoint;

// ---------------------------------------------------------------------------------
// QUICKDRAW RECT

struct QDRect {
  short               top;
  short               left;
  short               bottom;
  short               right;
};
typedef struct QDRect	QDRect;

// ---------------------------------------------------------------------------------
// ICON ALIGNMENT TYPE

typedef SInt16	IzIconAlignmentType;

enum {
  kIzAlignNone                    = 0x00,
  kIzAlignVerticalCenter          = 0x01,
  kIzAlignTop                     = 0x02,
  kIzAlignBottom                  = 0x03,
  kIzAlignHorizontalCenter        = 0x04,
  kIzAlignAbsoluteCenter          = kIzAlignVerticalCenter | kIzAlignHorizontalCenter,
  kIzAlignCenterTop               = kIzAlignTop | kIzAlignHorizontalCenter,
  kIzAlignCenterBottom            = kIzAlignBottom | kIzAlignHorizontalCenter,
  kIzAlignLeft                    = 0x08,
  kIzAlignCenterLeft              = kIzAlignVerticalCenter | kIzAlignLeft,
  kIzAlignTopLeft                 = kIzAlignTop | kIzAlignLeft,
  kIzAlignBottomLeft              = kIzAlignBottom | kIzAlignLeft,
  kIzAlignRight                   = 0x0C,
  kIzAlignCenterRight             = kIzAlignVerticalCenter | kIzAlignRight,
  kIzAlignTopRight                = kIzAlignTop | kIzAlignRight,
  kIzAlignBottomRight             = kIzAlignBottom | kIzAlignRight
};

// ---------------------------------------------------------------------------------
// ICON ALIGNMENT TYPE

typedef SInt16	IzIconTransformType;

enum {
  kIzTransformNone                = 0x00,
  kIzTransformDisabled            = 0x01,
  kIzTransformOffline             = 0x02,
  kIzTransformOpen                = 0x03,
  kIzTransformLabel1              = 0x0100,
  kIzTransformLabel2              = 0x0200,
  kIzTransformLabel3              = 0x0300,
  kIzTransformLabel4              = 0x0400,
  kIzTransformLabel5              = 0x0500,
  kIzTransformLabel6              = 0x0600,
  kIzTransformLabel7              = 0x0700,
  kIzTransformSelected            = 0x4000,
  kIzTransformSelectedDisabled    = kIzTransformSelected | kIzTransformDisabled,
  kIzTransformSelectedOffline     = kIzTransformSelected | kIzTransformOffline,
  kIzTransformSelectedOpen        = kIzTransformSelected | kIzTransformOpen
};

struct IzPenState {
	QDPoint		pnLoc;
	QDPoint		pnSize;
	int16_t		pnMode;
	uint8_t		pnPat[8];		// not used...
};
typedef struct IzPenState IzPenState;

typedef short   IzTruncCode;

enum {
	izTruncEnd			= 0,    /* Truncate at end */
	izTruncMiddle		= 0x4000, /* Truncate in middle */
	izSmTruncEnd		= 0,    /* Truncate at end - obsolete */
	izSmTruncMiddle		= 0x4000 /* Truncate in middle - obsolete */
};

typedef UInt32	IzThemeDrawState;

enum {
	kIzThemeStateInactive				= 0,
	kIzThemeStateActive					= 1,
	kIzThemeStatePressed				= 2,
	kIzThemeStateRollover				= 6,
	kIzThemeStateUnavailable			= 7,
	kIzThemeStateUnavailableInactive	= 8
};

// ---------------------------------------------------------------------------------
// POINT, RECT & COORDINATE TYPES

// IzFloatPt - a floating point coordinate
struct IzFloatPt {
	float		x;
	float		y;
};
typedef struct IzFloatPt	 IzFloatPt;

inline IzFloatPt IzFloatPtMake(float x, float y) { IzFloatPt pt; pt.x = x; pt.y = y; return pt; }

// IzFloatPt - a floating point rectangle
struct IzFloatRect {
	float		top;
	float		left;
	float		bottom;
	float		right;
};
typedef struct IzFloatRect	 IzFloatRect;

#define UGRAPHICS_FLOATING_POINT	FALSE

#if UGRAPHICS_FLOATING_POINT

	#define UGCOORD_DONTDRAW	FLT_MAX

	typedef float		IzCoord;
	typedef IzFloatRect	IzRect;
	typedef IzFloatPt	IzPoint;

#else

	struct IzLongPoint {
		int32_t		v;
		int32_t		h;
	};
	typedef struct IzLongPoint	IzLongPoint;

	struct IzLongRect {
		int32_t		top;
		int32_t		left;
		int32_t		bottom;
		int32_t		right;
	};
	typedef struct IzLongRect	IzLongRect;

	#define	UGCOORD_DONTDRAW	0x7FFF

	typedef SInt16			IzShortCoord;
	typedef SInt32			IzLongCoord;
	typedef IzShortCoord	IzCoord;

	typedef Rect			IzRect;
	typedef Point			IzPoint;

	struct IzSize {
		IzCoord		cx;
		IzCoord		cy;
	};
	typedef struct IzSize	 IzSize;

	extern const IzPoint	IzPoint_00;
	extern const IzRect		IzRect_0000;

	#define IZ_COORD_MIN	-32768
	#define IZ_COORD_MAX	+32767

	#ifdef __cplusplus
	inline IzPoint	IzPointMake(SInt16 h, SInt16 v) { Point pt; pt.h = h; pt.v = v; return pt; }
	inline IzPoint	IzTopLeft(IzRect r)				{ Point pt; pt.h = r.left; pt.v = r.top; return pt; }
	inline IzPoint	IzBotRight(IzRect r)			{ Point pt; pt.h = r.right; pt.v = r.bottom; return pt; }
	inline IzRect	IzPointToRect(Point pt)			{ IzRect r; r.left = r.right = pt.h; r.top = r.bottom = pt.v; return r; }
	inline IzRect	IzRectMake(
						SInt16	left,
						SInt16	top,
						SInt16	right,
						SInt16	bottom)
					{
						IzRect r;
						r.left = left;
						r.top = top;
						r.right = right;
						r.bottom = bottom;
						return r;
					}
	#endif

#endif

// ---------------------------------------------------------------------------------
//	WINDOWS GDI DEBUGGING
// ---------------------------------------------------------------------------------

#if TARGET_OS_WIN

	#ifdef __ISADORA_APP__
		#define	DEBUG_GDI		TRUE && DEBUG
	#else
		#define	DEBUG_GDI		FALSE
	#endif

	#if DEBUG_GDI

		HDC		__CreateCompatibleDC(HDC hdc, const char* inFile, int inLine);
		BOOL	__DeleteDC(HDC hdc, const char* inFile, int inLine);
		HBRUSH	__CreateSolidBrush(COLORREF color, const char* inFile, int inLine);
		HPEN    __CreatePen(int iStyle, int cWidth, COLORREF color, const char* inFile, int inLine);
		HPEN	__ExtCreatePen(DWORD iPenStyle, DWORD cWidth, CONST LOGBRUSH *plbrush, DWORD cStyle, CONST DWORD *pstyle, const char* inFile, int inLine);
		HRGN    __CreateRectRgn(int x1, int y1, int x2, int y2, const char* inFile, int inLine);
		HRGN    __CreateRoundRectRgn(int x1, int y1, int x2, int y2, int h, int v, const char* inFile, int inLine);
		HRGN    __CreateRectRgnIndirect(CONST RECT *lprect, const char* inFile, int inLine);
		HFONT	__CreateFontIndirect(CONST LOGFONTW *lplf, const char* inFile, int inLine);
		HBITMAP	__CreateDIBSection(HDC hdc, CONST BITMAPINFO *pbmi, UINT  usage, VOID **ppvBits, HANDLE hSection, DWORD offset, const char* inFile, int inLine);
		BOOL	__DeleteObject(HGDIOBJ ho, const char* inFile, int inLine);

		HFONT	__CreateFont(int cHeight,  int cWidth,  int cEscapement,  int cOrientation,  int cWeight,  DWORD bItalic,
								DWORD bUnderline,  DWORD bStrikeOut,  DWORD iCharSet,  DWORD iOutPrecision,  DWORD iClipPrecision,
								DWORD iQuality,  DWORD iPitchAndFamily, LPCWSTR pszFaceName, const char* inFile, int inLine);

		#define IzCreateCompatibleDC(a)						__CreateCompatibleDC((a), __FILE__, __LINE__)
		#define IzDeleteDC(a)								__DeleteDC((a), __FILE__, __LINE__)
		#define	IzCreateSolidBrush(a)						__CreateSolidBrush((a), __FILE__, __LINE__)
		#define	IzCreatePen(a, b, c)						__CreatePen((a), (b), (c), __FILE__, __LINE__)
		#define	IzExtCreatePen(a,b,c,d,e)					__ExtCreatePen((a), (b), (c), (d), (e), __FILE__, __LINE__)
		#define	IzCreateRectRgn(a, b, c, d)					__CreateRectRgn((a), (b), (c), (d), __FILE__, __LINE__)
		#define	IzCreateRoundRectRgn(a, b, c, d, e, f)		__CreateRoundRectRgn((a), (b), (c), (d), (e), (f), __FILE__, __LINE__)
		#define	IzCreateRectRgnIndirect(a)					__CreateRectRgnIndirect((a), __FILE__, __LINE__)
		#define	IzCreateFontIndirect(a)						__CreateFontIndirect((a), __FILE__, __LINE__)
		#define	IzCreateDIBSection(a, b, c, d, e, f)		__CreateDIBSection((a), (b), (c), (d), (e), (f), __FILE__, __LINE__)
		#define	IzDeleteObject(a)							__DeleteObject((a), __FILE__, __LINE__)

		#define	IzCreateFont(a, b, c, d, e, f, g, h, i, j, k, l, m, n)	__CreateFont((a),(b),(c),(d),(e),(f),(g),(h),(i),(j),(k),(l),(m),(n), __FILE__, __LINE__)
	
	#else

		#define	IzCreateCompatibleDC(a)					CreateCompatibleDC(a)
		#define	IzDeleteDC(a)							DeleteDC(a)
		#define	IzCreateSolidBrush(a)					CreateSolidBrush(a)
		#define	IzCreatePen(a, b, c)					CreatePen((a), (b), (c))
		#define	IzExtCreatePen(a,b,c,d,e)				ExtCreatePen((a), (b), (c), (d), (e))
		#define	IzCreateRectRgn(a, b, c, d)				CreateRectRgn((a), (b), (c), (d))
		#define	IzCreateRoundRectRgn(a, b, c, d, e, f)	CreateRoundRectRgn((a), (b), (c), (d), (e), (f))
		#define	IzCreateRectRgnIndirect(a)				CreateRectRgnIndirect((a))
		#define	IzCreateFontIndirect(a)					CreateFontIndirect((a))
		#define IzCreateDIBSection(a, b, c, d, e, f)	CreateDIBSection((a), (b), (c), (d), (e), (f))
		#define	IzDeleteObject(a)						DeleteObject((a))

		#define	IzCreateFont(a, b, c, d, e, f, g, h, i, j, k, l, m, n)	CreateFont((a),(b),(c),(d),(e),(f),(g),(h),(i),(j),(k),(l),(m),(n))

	#endif

#endif	// #if TARGET_OS_WIN

#endif	// #ifndef _H_IZGraphics
