// =================================================================================
//	IZQTDebugging					(c) 2016 Mark F. Coniglio -- All Rights Reserved
// =================================================================================
// Replacement for QuickTime/Macintosh functions that deal with debugging

#ifndef _H_IZQTDebugging
#define _H_IZQTDebugging

#include "IZQT.h"
#include "IZQTMemory.h"
#include "IZQTSystem.h"
#include "IZQTDebugBreak.h"

#define				IzDebugBreak()					debug_break()

#if TARGET_OS_MAC

#define				IzDebugBreakStr(inCString)		{ printf("%s\n", inCString); IzDebugBreak(); }

#endif	// #if TARGET_OS_MAC

#if TARGET_OS_WIN

#define				IzDebugBreakStr(debuggerMsg)	{ OutputDebugStringA(debuggerMsg); IzDebugBreak(); }

#endif	// #if TARGET_OS_WIN

#if DEBUG
	#define				IzDebugBreakIfDebugging()		IzDebugBreak()
#else
	#define				IzDebugBreakIfDebugging()		{ }
#endif

#endif	// #ifndef _H_IZQTDebugging
