// =================================================================================
//	IZQTMemory						(c) 2016 Mark F. Coniglio -- All Rights Reserved
// =================================================================================
// Replacement for QuickTime/Macintosh functions that deal with memory

#ifndef _H_IZQTMemory
#define _H_IZQTMemory

#ifdef __cplusplus

#include "IZDefinitions.h"

// --------------------------------------------------------------------------------
//
// IZQT HANDLE + POINTER FUNCTIONS
//
// --------------------------------------------------------------------------------

	typedef size_t	QTHdlSize;

	OSErr		QTMemError();

	Handle		QTNewHandle(
					QTHdlSize	byteCount);
				
	Handle		QTNewHandleClear(
					QTHdlSize	byteCount);

	void		QTDisposeHandle(
					Handle		h);

	void		QTSetHandleSize(
					Handle		h,
					QTHdlSize	newSize);

	QTHdlSize	QTGetHandleSize(
					Handle		h);

	void		QTMoveHHi(
					Handle		h);

	void*		QTHLock(
					Handle		h);
				
	inline void	QTHlockHi(
					Handle		h)
				{
					QTHLock(h);
				}

	void		QTHUnlock(
					Handle		h);

	SInt8		QTHGetState(
					Handle		h);

	void		QTHSetState(
					Handle		h,
					SInt8		flags);

	OSErr		QTHandToHand(
					Handle*		theHndl);

	OSErr		QTPtrToHand(
					const void*	srcPtr,
					Handle*		dstHndl,
					size_t      size);

	void		QTHPurge(
					Handle		h);

	void		QTHNoPurge(
					Handle		h);

	Ptr			QTNewPtr(
					QTHdlSize	byteCount);

	Ptr			QTNewPtrClear(
					QTHdlSize	byteCount);

	void		QTDisposePtr(
					Ptr			p);

	QTHdlSize	QTGetPtrSize(
					Ptr			p);

	void		QTBlockMove(
					const void*		srcPtr,
					void*			destPtr,
					QTHdlSize		byteCount);

	void		QTBlockMoveData(
					const void*		srcPtr,
					void*			destPtr,
					QTHdlSize		byteCount);
	
	// added 3.0.9b15
	void		QTCopyDataToHandle(
					Handle			inDstHandle,
					const void*		inData,
					size_t			inDataLength);

	// added 3.0.9b15
	void		QTCopyHandleToHandle(
					Handle			inDstHandle,
					Handle			inSrcHandle);

#endif	// #ifdef __cplusplus

#endif	// #ifndef _H_IZQTMemory
