// =================================================================================
//	IZQTTypes						(c) 2018 Mark F. Coniglio -- All Rights Reserved
// =================================================================================
// Replacement for QuickTime/Macintosh structures

#ifndef _H_IZQTTypes
#define _H_IZQTTypes

#include "IZDefinitions.h"

// ---------------------------------------------------------------------------------
// PIXEL DEPTH
typedef OSType	IzCodecQ;		// codec quality

// ---------------------------------------------------------------------------------
// QUICKTIME FILE TYPE CODES

#if IZ_64BIT

// from "QuickTimeComponents.h"
// __QUICKTIMECOMPONENTS__

enum {
	kIzQTFileTypeAIFF						= 'AIFF',
	kIzQTFileTypeAIFC						= 'AIFC',
	kIzQTFileTypeDVC						= 'dvc!',
	kIzQTFileTypeMIDI						= 'Midi',
	kIzQTFileTypePicture					= 'PICT',
	kIzQTFileTypeMovie						= 'MooV',
	kIzQTFileTypeText						= 'TEXT',
	kIzQTFileTypeWave						= 'WAVE',
	kIzQTFileTypeSystemSevenSound			= 'sfil',
	kIzQTFileTypeMuLaw						= 'ULAW',
	kIzQTFileTypeAVI						= 'VfW ',
	kIzQTFileTypeSoundDesignerII			= 'Sd2f',
	kIzQTFileTypeAudioCDTrack				= 'trak',
	kIzQTFileTypePICS						= 'PICS',
	kIzQTFileTypeGIF						= 'GIFf',
	kIzQTFileTypePNG						= 'PNGf',
	kIzQTFileTypeTIFF						= 'TIFF',
	kIzQTFileTypePhotoShop					= '8BPS',
	kIzQTFileTypeSGIImage					= '.SGI',
	kIzQTFileTypeBMP						= 'BMPf',
	kIzQTFileTypeJPEG						= 'JPEG',
	kIzQTFileTypeJFIF						= 'JPEG',
	kIzQTFileTypeMacPaint					= 'PNTG',
	kIzQTFileTypeTargaImage					= 'TPIC',
	kIzQTFileTypeQuickDrawGXPicture			= 'qdgx',
	kIzQTFileTypeQuickTimeImage				= 'qtif',
	kIzQTFileType3DMF						= '3DMF',
	kIzQTFileTypeFLC						= 'FLC ',
	kIzQTFileTypeFlash						= 'SWFL',
	kIzQTFileTypeFlashPix					= 'FPix',
	kIzQTFileTypeMP4						= 'mpg4',
	kIzQTFileTypePDF						= 'PDF ',
	kIzQTFileType3GPP						= '3gpp',
	kIzQTFileTypeAMR						= 'amr ',
	kIzQTFileTypeSDV						= 'sdv ',
	kIzQTFileType3GP2						= '3gp2',
	kIzQTFileTypeAMC						= 'amc ',
	kIzQTFileTypeJPEG2000					= 'jp2 ',

	kIzQTFileTypeMPEG1						= 'mpg ',
	kIzQTFileTypeMPEG2						= 'm2v ',
	kIzQTFileTypeMPEG3						= 'mp3 ',
	kIzQTFileTypeM4P						= 'm4p ',
	kIzQTFileTypeM4V						= 'm4v ',
	kIzQTFileTypeM4A						= 'm4a ',
	kIzQTFileTypeWMV						= 'wmv ',
	kIzQTFileTypeDIVX						= 'divx',
	kIzQTFileTypeFLV						= 'flv ',
	kIzQTFileTypeQuartzComposer				= 'qtz ',
	kIzQTFileTypeM2TS						= 'm2ts',

	kIzQTFileTypeMKV						= 'mkv ',

	// this is a pseudo four char code for an animated GIF image
	// that will be played as a movie
	kIzQTFileTypeMovieGIF					= 'mGIF',

};

// from ImageCompression.h
// __IMAGECOMPRESSION__

enum {
	kIzCodecLosslessQuality				= 0x00000400,
	kIzCodecMaxQuality					= 0x000003FF,
	kIzCodecMinQuality					= 0x00000000,
	kIzCodecLowQuality					= 0x00000100,
	kIzCodecNormalQuality				= 0x00000200,
	kIzCodecHighQuality					= 0x00000300
};

enum {
	kIzQTGraphicsModeStraightAlpha			= 256,
	kIzQTGraphicsModePreWhiteAlpha			= 257,
	kIzQTGraphicsModePreBlackAlpha			= 258,
	kIzQTGraphicsModeComposition			= 259,
	kIzQTGraphicsModeStraightAlphaBlend		= 260,
	kIzQTGraphicsModePreMulColorAlpha		= 261,
	kIzQTGraphicsModePerComponentAlpha		= 272
};

#endif

#endif	// #ifndef IZQTTypes