// =================================================================================
//	IZTime						(c) 2018 Mark F. Coniglio -- All Rights Reserved
// =================================================================================

#ifndef _H_IZTime
#define _H_IZTime

#include <float.h>

#ifdef __cplusplus

#if TARGET_OS_MAC
	#define	IZ_Sleep(a)		usleep((a) * 1000)
#elif TARGET_OS_WIN
	#define	IZ_Sleep(a)		Sleep(a)
#endif

typedef double			IzSeconds;
const IzSeconds			kIzMaxSeconds = DBL_MAX;
const IzSeconds			kIzSeconds_TimeoutInfinite = kIzMaxSeconds;

typedef	uint64_t		IzNanoseconds;
const IzNanoseconds		kIzMaxNanoseconds = IzNanoseconds(-1);
const IzNanoseconds		kIzNanoseconds_TimeoutInfinite = kIzMaxNanoseconds;

typedef	uint64_t		IzMicroseconds;
const IzMicroseconds	kIzMaxMicroseconds = IzMicroseconds(-1);
const IzMicroseconds	kIzMicroseconds_TimeoutInfinite = kIzMaxMicroseconds;

typedef	uint32_t		IzMilliseconds;
const IzMilliseconds	kIzMaxMilliseconds = IzMilliseconds(-1);
const IzMilliseconds	kIzMilliseconds_TimeoutInfinite = kIzMaxMilliseconds;

typedef	uint32_t		IzQTTicks;
const IzQTTicks			kIzMaxQTTicks = IzQTTicks(-1);
const IzQTTicks			kIzQTTicks_TimeoutInfinite = kIzMaxQTTicks;

IzSeconds			IZ_TimeSeconds();

IzNanoseconds		IZ_TimeNanoseconds();

IzMicroseconds		IZ_TimeMicroseconds();

IzMilliseconds		IZ_TimeMilliseconds();

IzQTTicks			IZ_TickCount();

IzQTTicks			IZ_TimeSecondsToQTTicks(
						IzSeconds	inSeconds);

IzSeconds			IZ_TimeQTTicksToSeconds(
						IzQTTicks	inQTicks);

#endif	// #ifdef __cplusplus

#endif	// #ifndef _H_IZTime