// =================================================================================
//	IzzyGWorld						  (C)2002 Mark F. Coniglio -- All Rights Reserved.
// =================================================================================
//
//	Isadora code should never call NewGWorld. Instead it should call IzzyNewGWorld,
//	as there is special interpretation of the inFormat argument depending on
//	whether or not this is a big or little endian system.

#ifndef _H_IzzyGWorld
#define _H_IzzyGWorld

#include "IZQT.h"
#include "IsadoraTypes.h"

OSStatus
IzzyNewNativeBitmap(
	NativeBitmap*		outNativeBitmap,
	short				inPixelDepth,
	const IzRect&			inBoundsRect,
	OSType				inFormat = 0);		// a value of 0 means 32 bit ARGB
	
#if IZ_ALLOW_QUICKTIME && NATIVE_BITMAP_IS_GWORLD
OSStatus
IzzyNewNativeBitmapFromPtr(
	NativeBitmap*		outNativeBitmap,
	short				inPixelDepth,
	const IzRect&			inBoundsRect,
	OSType				inFormat,
	void*				inImageData,
	size_t				inImageRowBytes);
#endif

void
IzzyDisposeNativeBitmap(
	NativeBitmap		inNativeBitmap);

UInt32
IzzyCalculateRowBytesForBounds(
	const IzRect&			inBoundsRect);
	
UInt32
IzzyCalculateRowBytesForWidth(
	SInt32				inWidth);
	
#if !NATIVE_BITMAP_IS_GWORLD
void
IzzyCopyNativeBitmap(
	NativeBitmap		inSrcBitmap,
	NativeBitmap		inDstBitmap,
	const IzRect*			inSrcRect,			// CAN BE NULL FOR FULL FRAME
	const IzRect*			inDstRect,			// CAN BE NULL FOR FULL FRAME
	SInt16				inXFerModeCode,
	RGBColor*			inRGBBlendColor		/* = NULL */,
	bool				inFlipVertically	/* = FALSE */,
	bool				inInvertColors		/* = FALSE */);
#endif

#if IZ_ALLOW_QUICKTIME

OSStatus
IzzyNewGWorld(
	GWorldPtr *			outOffscreenGWorld,
	short				inPixelDepth,
	const IzRect *		boundsRect,
	CTabHandle			inCTable,
	GDHandle			inGDevice,
	GWorldFlags			inFlags,
	OSType				inFormat = 0);
	
void
IzzyDisposeGWorld(
	GWorldPtr			inGWorld);

#endif


// ---------------------------------------------------------------------------------
//	QUICKTIME ROWBYTES CALCULATION
// ---------------------------------------------------------------------------------
// to allow a test about our assumptions regarding QuickTime's calculation
// of the rowbytes value for GWorld, change FALSE && DEBUG to TRUE && DEBUG
// below

#define DEBUG_TEST_BITMAP_SIZE_WITH_READ_WRITE	(FALSE && DEBUG)

// FOR TESTING PURPOSES ONLY
#define TEST_QUICKTIME_ROWBYTES_CALCULATION		(FALSE && DEBUG)

#if TEST_QUICKTIME_ROWBYTES_CALCULATION

	void TestQuickTimeRowBytesCalculation();

#endif

#endif
