// =================================================================================
//	OpenGLIncludes					(c) 2012 Mark F. Coniglio. All rights reserved.
// =================================================================================

#ifndef _H_OpenGLIncludes
#define _H_OpenGLIncludes

// set this to TRUE if OpenGL 2.0 is required
#define GL_REQUIRE_OPEN_GL_2_0							TRUE

// this flag indicates if GL_TEXTURE_2D requires
// dimensions that are a power of two
#define	GL_TEXTURE_2D_REQUIRES_POWER_OF_TWO_SIZE		(!GL_REQUIRE_OPEN_GL_2_0)
#define	GL_TEXTURE_2D_ACCEPTS_ANY_SIZE					(GL_REQUIRE_OPEN_GL_2_0)

#if TARGET_OS_MAC
	
	#include <OpenGL/gl.h>
	#include <OpenGL/glu.h>
	#include <OpenGL/glext.h>
	
	#include <AGL/agl.h>
	#include <OpenGL/OpenGL.h>

#elif TARGET_OS_WIN
	
	#ifdef __ISADORA_APP__
		// #include <gl/glew.h>
		// #include <gl/wglew.h>
	#endif

	#include <gl/gl.h>
	#include <gl/glu.h>
	#include <gl/glext.h>
	#pragma comment(lib, "opengl32.lib")
	#pragma comment(lib, "glu32.lib")

	#include <gl/wglext.h>
	#define WGL_WGLEXT_PROTOTYPES
	#include <wingdi.h>
	
#endif

#endif
