// ===========================================================================
//	VidFormats					  (C)2007 Mark F. Coniglio. All rights reserved.
// ===========================================================================
// Defines video formats used throughout Isadora and constants related to
// then. Notably kIzzyRGBFormat or kIzzyRGBFormat can be found in the mFormat
// member of the ImageBuffer struct.

#ifndef _H_VIDFORMATS
#define _H_VIDFORMATS

	#ifndef TARGET_CPU_PPC
		#error "TARGET_CPU_PPC must be defined here"
	#endif

	#ifndef TARGET_CPU_X86
		#error "TARGET_CPU_X86 must be defined here"
	#endif

	#define	kIzzyInvalidVidFormat				0						// an invalid format

	#if TARGET_CPU_PPC
		
		#define	kIzzyRGBFormat					k32ARGBPixelFormat		// gworld format: ARGB
		
		#define	kGWorldPixelComponentOrder_ARGB	1						// Set to 1 when RGB GWorlds are organized in the ARGB (BigEndian) memory layout
		
		#define	kIzzyYUVFormat					k2vuyPixelFormat		// mem layout: CbY0CrY1

	#else

		#define	kIzzyRGBFormat					k32BGRAPixelFormat		// gworld format: BGRA
		
		#define	kGWorldPixelComponentOrder_ARGB	1						// Set to 1 when RGB GWorlds are organized in the ARGB (BigEndian) memory layout
		
		#if TARGET_OS_MAC
		
		#define	kIzzyYUVFormat					k2vuyPixelFormat		// mem layout: Y1CrY0Cb - UYVY 4:2:2
		
		#elif TARGET_OS_WIN
		
		#define	kIzzyYUVFormat					kYUVSPixelFormat		// mem layout: Y1CrY0Cb - UYVY 4:2:2
		
		#endif

	#endif

#endif
