// =================================================================================
//	WGLProcAccess						(C)2012 Mark F. Coniglio. All rights reserved.
// =================================================================================

// INSTRUCTIONS: in your .c file, define the accessor that will return
// a CGLContext* as __ctx__accessor. Then you may use these OpenGL functions
// as discovered on a per-contex basis
//
// examples
// #define __ctx__accessor	this
// #define __ctx__accessor	GetGLContext()
// etc.

#ifndef _H_WGLProcAccess
#define _H_WGLProcAccess

#if TARGET_OS_WIN

	#ifdef glBlendColor
	#undef glBlendColor
	#endif
	#ifdef glBlendFuncSeparate
	#undef glBlendFuncSeparate
	#endif
	#ifdef glBlendEquationSeparate
	#undef glBlendEquationSeparate
	#endif

	#ifdef glCompressedTexSubImage2D
	#undef glCompressedTexSubImage2D
	#endif

	#ifdef glActiveTextureARB
	#undef glActiveTextureARB
	#endif

	#ifdef glGenBuffersARB
	#undef glGenBuffersARB
	#endif
	#ifdef glDeleteBuffersARB
	#undef glDeleteBuffersARB
	#endif
	#ifdef glBindBufferARB
	#undef glBindBufferARB
	#endif
	#ifdef glMapBufferARB
	#undef glMapBufferARB
	#endif
	#ifdef glUnmapBufferARB
	#undef glUnmapBufferARB
	#endif
	#ifdef glBufferDataARB
	#undef glBufferDataARB
	#endif
	#ifdef glGetBufferParameterivARB
	#undef glGetBufferParameterivARB
	#endif
	#ifdef glBufferSubDataARB
	#undef glBufferSubDataARB
	#endif

	#ifdef glGenFramebuffersEXT
	#undef glGenFramebuffersEXT
	#endif
	#ifdef glDeleteFramebuffersEXT
	#undef glDeleteFramebuffersEXT
	#endif
	#ifdef glBindFramebufferEXT
	#undef glBindFramebufferEXT
	#endif
	#ifdef glFramebufferRenderbufferEXT
	#undef glFramebufferRenderbufferEXT
	#endif
	#ifdef glFramebufferTexture2DEXT
	#undef glFramebufferTexture2DEXT
	#endif
	#ifdef glCheckFramebufferStatusEXT
	#undef glCheckFramebufferStatusEXT
	#endif
	#ifdef glIsFramebufferEXT
	#undef glIsFramebufferEXT
	#endif

	#ifdef glGenRenderbuffersEXT
	#undef glGenRenderbuffersEXT
	#endif
	#ifdef glDeleteRenderbuffersEXT
	#undef glDeleteRenderbuffersEXT
	#endif
	#ifdef glBindRenderbufferEXT
	#undef glBindRenderbufferEXT
	#endif
	#ifdef glRenderbufferStorageEXT
	#undef glRenderbufferStorageEXT
	#endif
	#ifdef glGenerateMipmapEXT
	#undef glGenerateMipmapEXT
	#endif

	#define	glBlendColor					__ctx__accessor->wglBlendColor
	#define	glBlendFuncSeparate				__ctx__accessor->wglBlendFuncSeparate
	#define	glBlendEquationSeparate			__ctx__accessor->wglBlendEquationSeparate

	#define glCompressedTexSubImage2D		__ctx__accessor->wglCompressedTexSubImage2D

	#define glActiveTextureARB				__ctx__accessor->wglActiveTextureARB

	#define	glGenBuffersARB					__ctx__accessor->wglGenBuffersARB
	#define	glDeleteBuffersARB				__ctx__accessor->wglDeleteBuffersARB
	#define	glBindBufferARB					__ctx__accessor->wglBindBufferARB
	#define	glMapBufferARB					__ctx__accessor->wglMapBufferARB
	#define	glUnmapBufferARB				__ctx__accessor->wglUnmapBufferARB
	#define	glBufferDataARB					__ctx__accessor->wglBufferDataARB
	#define	glGetBufferParameterivARB		__ctx__accessor->wglGetBufferParameterivARB
	#define	glBufferSubDataARB				__ctx__accessor->wglBufferSubDataARB

	#define glGenFramebuffersEXT			__ctx__accessor->wglGenFramebuffersEXT
	#define glDeleteFramebuffersEXT			__ctx__accessor->wglDeleteFramebuffersEXT
	#define glBindFramebufferEXT			__ctx__accessor->wglBindFramebufferEXT
	#define glFramebufferRenderbufferEXT	__ctx__accessor->wglFramebufferRenderbufferEXT
	#define glFramebufferTexture2DEXT		__ctx__accessor->wglFramebufferTexture2DEXT
	#define glCheckFramebufferStatusEXT		__ctx__accessor->wglCheckFramebufferStatusEXT
	#define glIsFramebufferEXT				__ctx__accessor->wglIsFramebufferEXT

	#define glGenRenderbuffersEXT			__ctx__accessor->wglGenRenderbuffersEXT
	#define glDeleteRenderbuffersEXT		__ctx__accessor->wglDeleteRenderbuffersEXT
	#define glBindRenderbufferEXT			__ctx__accessor->wglBindRenderbufferEXT
	#define glRenderbufferStorageEXT		__ctx__accessor->wglRenderbufferStorageEXT

	#define glGenerateMipmapEXT				__ctx__accessor->wglGenerateMipmapEXT

	#ifdef glCreateShaderObjectARB
	#undef glCreateShaderObjectARB
	#endif
	#ifdef glCreateProgramObjectARB
	#undef glCreateProgramObjectARB
	#endif
	#ifdef glDeleteObjectARB
	#undef glDeleteObjectARB
	#endif
	#ifdef glShaderSourceARB
	#undef glShaderSourceARB
	#endif
	#ifdef glCompileShaderARB
	#undef glCompileShaderARB
	#endif
	#ifdef glLinkProgramARB
	#undef glLinkProgramARB
	#endif
	#ifdef glGetObjectParameterivARB
	#undef glGetObjectParameterivARB
	#endif
	#ifdef glGetInfoLogARB
	#undef glGetInfoLogARB
	#endif
	#ifdef glAttachObjectARB
	#undef glAttachObjectARB
	#endif
	#ifdef glUseProgramObjectARB
	#undef glUseProgramObjectARB
	#endif
	#ifdef glGetUniformLocationARB
	#undef glGetUniformLocationARB
	#endif
	#ifdef glGetAttribLocationARB
	#undef glGetAttribLocationARB
	#endif
	#ifdef glUniform1f
	#undef glUniform1f
	#endif
	#ifdef glUniform2f
	#undef glUniform2f
	#endif
	#ifdef glUniform3f
	#undef glUniform3f
	#endif
	#ifdef glUniform4f
	#undef glUniform4f
	#endif
	#ifdef glUniform1i
	#undef glUniform1i
	#endif
	#ifdef glUniform2i
	#undef glUniform2i
	#endif
	#ifdef glUniform3i
	#undef glUniform3i
	#endif
	#ifdef glUniform4i
	#undef glUniform4i
	#endif
	#ifdef glActiveTexture
	#undef glActiveTexture
	#endif
	#ifdef glClientActiveTexture
	#undef glClientActiveTexture
	#endif
	#ifdef glVertexAttribPointer
	#undef glVertexAttribPointer
	#endif
	#ifdef glEnableVertexAttribArray
	#undef glEnableVertexAttribArray
	#endif
	#ifdef glDisableVertexAttribArray
	#undef glDisableVertexAttribArray
	#endif

	#define glCreateShaderObjectARB			__ctx__accessor->wglCreateShaderObjectARB
	#define glCreateProgramObjectARB		__ctx__accessor->wglCreateProgramObjectARB
	#define glDeleteObjectARB				__ctx__accessor->wglDeleteObjectARB
	#define glShaderSourceARB				__ctx__accessor->wglShaderSourceARB
	#define glCompileShaderARB				__ctx__accessor->wglCompileShaderARB
	#define glLinkProgramARB				__ctx__accessor->wglLinkProgramARB
	#define glGetObjectParameterivARB		__ctx__accessor->wglGetObjectParameterivARB
	#define glGetInfoLogARB					__ctx__accessor->wglGetInfoLogARB
	#define glAttachObjectARB				__ctx__accessor->wglAttachObjectARB
	#define glUseProgramObjectARB			__ctx__accessor->wglUseProgramObjectARB
	#define glGetUniformLocationARB			__ctx__accessor->wglGetUniformLocationARB
	#define glGetAttribLocationARB			__ctx__accessor->wglGetAttribLocationARB

	#define glUniform1f						__ctx__accessor->wglUniform1f
	#define glUniform2f						__ctx__accessor->wglUniform2f
	#define glUniform3f						__ctx__accessor->wglUniform3f
	#define glUniform4f						__ctx__accessor->wglUniform4f

	#define glUniform1i						__ctx__accessor->wglUniform1i
	#define glUniform2i						__ctx__accessor->wglUniform2i
	#define glUniform3i						__ctx__accessor->wglUniform3i
	#define glUniform4i						__ctx__accessor->wglUniform4i

	#define	glActiveTexture					__ctx__accessor->wglActiveTexture
	#define	glClientActiveTexture			__ctx__accessor->wglClientActiveTexture

	#define	glVertexAttribPointer			__ctx__accessor->wglVertexAttribPointer
	#define	glEnableVertexAttribArray		__ctx__accessor->wglEnableVertexAttribArray
	#define	glDisableVertexAttribArray		__ctx__accessor->wglDisableVertexAttribArray

	typedef char			GLcharARB;
	typedef unsigned int	GLhandleARB;
	
#endif

#endif
